var selected_tree_row = null;

var audio_player = null;
var audio_player_ready = false;
var audio_player_queue;

function tree_select_callback(el)
  {
  var didl;
  var container = document.getElementById("list");

  if(selected_tree_row == el)
    return;

  if(selected_tree_row != null)
    selected_tree_row.setAttribute("class", "treerow");

  el.setAttribute("class", "treerow treerow_selected");

  while(container.firstChild != null)
    container.removeChild(container.firstChild);

  didl = browse_children(el.getAttribute("id"));
  handle_didl_items(didl);

  selected_tree_row = el;
  }

function tree_expand_callback(event, el)
  {
  var didl;
  var parent = el.parentNode;
  if(el.getAttribute("class") == "tree_elem handleclosed")
    {
    el.setAttribute("class", "tree_elem handleopen");
    didl = browse_children(parent.getAttribute("id"));
    handle_didl_containers(didl, parent);
    }
  else
    {
    var child;
    el.setAttribute("class", "tree_elem handleclosed");
    while(true)
      {
      child = parent.nextSibling;
      if((child == null) || (child.depth <= parent.depth))
	break;
      parent.parentNode.removeChild(child);
      }
    }
  stop_propagate(event);
  }

function player_created()
  {
  audio_player_ready = true;

  /* Flush the queue */
  while(audio_player_queue.length > 0)
    {
    audio_player.add_track(audio_player_queue[0].track,
                           audio_player_queue[0].do_play);
    audio_player_queue.shift();
    }
  }

function add_audio_track(track, do_play)
  {
  if((audio_player == null) || (audio_player.closed == true))
    {
    audio_player_ready = false;
    audio_player = window.open("/static/audioplayer.html",
				"Audio player",
			        "width=460,height=320,location=no,menubar=no");
    }
  if(audio_player_ready == false)
    {
    var queue = new Object;
    queue.track = track;
    queue.do_play = do_play;
    /* Push to queue */
    audio_player_queue.push(queue);
    }
  else
    /* Send the didl data of the audio track to the player window */
    audio_player.add_track(track, do_play);
  }

function play_song(id)
  {
  var didl;
  didl = browse_metadata(id);
  add_audio_track(didl.getElementsByTagName("item")[0], true);
  }

function add_song(id)
  {
  var didl;
  didl = browse_metadata(id);
  add_audio_track(didl.getElementsByTagName("item")[0], false);
  }

function play_album(id)
  {
  var didl;
  var i;
  var tracks;
  var do_play;
  do_play = true;

  didl = browse_children(id);
  tracks = didl.getElementsByTagName("DIDL-Lite")[0].childNodes;

  for(i = 0; i < tracks.length; i++)
    {
    if(get_didl_element(tracks[i], "class") ==
       "object.item.audioItem.musicTrack")
      {
      add_audio_track(tracks[i], do_play);
      do_play = false;
      }
    }
  }

function add_album(id)
  {
  var didl;
  var i;
  var tracks;
  didl = browse_children(id);
  tracks = didl.getElementsByTagName("DIDL-Lite")[0].childNodes;

  for(i = 0; i < tracks.length; i++)
    {
    if(get_didl_element(tracks[i], "class") == "object.item.audioItem.musicTrack")
      add_audio_track(tracks[i], false);
    }
  }

function create_play_button(func, id)
  {
  var ret = document.createElement("a");
  ret.setAttribute("href", "javascript: " + func + "('" + id + "')" );
  ret.setAttribute("class", "button play");
  ret.setAttribute("title", "Play");
/*
  ret.onmousedown = function(evt) {
    evt.preventDefault();
    stop_propagate(evt);
    };
*/
  return ret;
  }

function create_add_button(func, id)
  {
  var ret = document.createElement("a");
  ret.setAttribute("href", "javascript: " + func + "('" + id + "')" );
  ret.setAttribute("class", "button add");
  ret.setAttribute("title", "Add to playlist");
/*
  ret.onmousedown = function(evt) {
    evt.preventDefault();
    stop_propagate(evt);
    };
*/
  ret.ondragstart = function() {
     return false;
  };
  return ret;
  }

function create_song_play_button(id)
  {
  return create_play_button("play_song", id);
  }

function create_album_play_button(id)
  {
  return create_play_button("play_album", id);
  }

function create_song_add_button(id)
  {
  return create_add_button("add_song", id);
  }

function create_album_add_button(id)
  {
  return create_add_button("add_album", id);
  }

function get_movie_poster(el)
  {
  var i;
  var protocol_info;
  var resolution;
  var res_arr;
  var res = el.getElementsByTagName("res");

  if(res == null)
    return null;

  for(i = 0; i < res.length; i++)
    {
    protocol_info = res[i].getAttribute("protocolInfo").split(":");
    if(protocol_info[0] != "http-get")
      continue;
    if(protocol_info[2].indexOf("image/") != 0)
      continue;
    resolution = res[i].getAttribute("resolution");
    if(resolution == null)
      continue;
    res_arr = resolution.split("x");
    if((parseInt(res_arr[0]) > 220) ||
       (parseInt(res_arr[0]) > 330))
      continue;
    return res[i].textContent;
    }
  return null;
  }

function get_movie_poster_orig(el)
  {
  var i;
  var protocol_info;
  var resolution;
  var res_arr;
  var max_width = 0;
  var max_index = 0;
  var width;

  var res = el.getElementsByTagName("res");

  if(res == null)
    return null;

  for(i = 0; i < res.length; i++)
    {
    protocol_info = res[i].getAttribute("protocolInfo").split(":");
    if(protocol_info[0] != "http-get")
      continue;
    if(protocol_info[2].indexOf("image/") != 0)
      continue;
    resolution = res[i].getAttribute("resolution");
    if(resolution == null)
      continue;
    res_arr = resolution.split("x");
    width = parseInt(res_arr[0]);

    if(width > max_width)
      {
      max_width = width;
      max_index = i;
      }
    continue;
    }
  return res[max_index].textContent;
  }

function create_movie_poster(el)
  {
  var str;
  var img;

  str =	get_movie_poster(el);
  if(str == null)
    return null;

  if(str != null)
    {
    img = document.createElement("img");
    img.setAttribute("src", str);
    img.setAttribute("width", "220");
    img.setAttribute("height", "330");
    img.setAttribute("class", "albumcover");
    }

  str =	get_movie_poster_orig(el);

  if(str != null)
    {
    var a = document.createElement("a");
    a.setAttribute("href", str);
    a.setAttribute("target", "_new");
    a.appendChild(img);
    return a;
    }
  else
    {
    return img;
    }
  }

function get_album_cover(el)
  {
  var uris = get_didl_elements(el, "albumArtURI");
  if(!uris)
    return "/static/icons/cover_160.png";
  return uris[0].textContent;
  }

function get_album_cover_orig(el)
  {
  var uris = get_didl_elements(el, "albumArtURI");
  if(!uris)
    return null;
  return uris[uris.length-1].textContent;
  }

function create_album_cover(el)
  {
  var str;
  var img;

  str =	get_album_cover(el);

  img = document.createElement("img");
  img.setAttribute("src", str);
  img.setAttribute("width", "160");
  img.setAttribute("height", "160");
  img.setAttribute("class", "albumcover");

  str =	get_album_cover_orig(el);

  if(str != null)
    {
    var a = document.createElement("a");
    a.setAttribute("href", str);
    a.setAttribute("target", "_new");
    a.appendChild(img);
    return a;
    }
  else
    {
    return img;
    }
  }


function add_media_locations(el, parent)
  {
  var a;
  var i;
  var protocol_info;
  var ext;
  var idx;
  var idx2;
  var text;
  var str;
  var added = 0;
  var res = el.getElementsByTagName("res");
  var bitrate;
  var isav = 0;

  for(i = 0; i < res.length; i++)
    {
    protocol_info = res[i].getAttribute("protocolInfo").split(":");
    if(protocol_info[0] != "http-get")
      continue;

    /* We only generate links for URLS with a file extension */

    str = get_extension(res[i].textContent);
    if(str == null)
      continue;
    str = str.toUpperCase();

    if((protocol_info[2].indexOf("audio/") == 0) ||
       (protocol_info[2].indexOf("video/") == 0))
      isav = 1;

    if((isav != 0) && (protocol_info[2].indexOf("image/") == 0))
      continue;

    bitrate = res[i].getAttribute("bitrate");
    if(bitrate != null)
      {
      var bitrate_int;
      bitrate_int = parseInt(bitrate);
      // bitrate is actually byterate

      if(bitrate_int > 0)
	{
        bitrate_int *= 8;
        bitrate_int /= 1000;
        str += " (" + bitrate_int + " kbps)";
	}
//      else if(protocol_info[2] == "audio/mpeg")
//        str += " (VBR)";
      }
    else if(protocol_info[2] == "audio/mpeg")
      str += " (VBR)";


    text = document.createTextNode(str);

    a = document.createElement("a");
    a.setAttribute("href", res[i].textContent);
    a.appendChild(text);
    a.setAttribute("class", "medialink");

//    a.setAttribute("title", "Play");

    if(added > 0)
      parent.appendChild(document.createTextNode(" "));

    parent.appendChild(a);

    added++;
    }
  }

function add_music_info(el, parent)
  {
  var res = el.getElementsByTagName("res");
  var v;
  var str = "";
  var text;

  if(res == null)
    return;
  v =	res[0].getAttribute("sampleFrequency");
  if(v != null)
    str += v + " Hz ";

  v = res[0].getAttribute("nrAudioChannels");
  if(v != null)
    {
    if(v == "1")
      str += "Mono ";
    else if(v == "2")
      str += "Stereo ";
    else
      str += v + " Channels";

    }
  text = document.createTextNode(str);
  parent.appendChild(text);
  }

function add_video_info(el, parent)
  {
  var res = el.getElementsByTagName("res");
  var str = "";
  var v;
  var text;
  if(res == null)
    return;

  v = res[0].getAttribute("resolution");
  if(v != null)
    str += v;
  text = document.createTextNode(str);
  parent.appendChild(text);
  }

function create_type_cell(type)
  {
  var ret, cell;
  ret = document.createElement("img");
  ret.setAttribute("width", "16");
  ret.setAttribute("height", "16");
  if(type == "audio")
    ret.setAttribute("src", "/static/icons/audio_black_16.png");
  else if(type == "video")
    ret.setAttribute("src", "/static/icons/video_black_16.png");
  else if(type == "image")
    ret.setAttribute("src", "/static/icons/image_black_16.png");

  cell = document.createElement("td");
  cell.setAttribute("style", "width: 16px;");
  cell.appendChild(ret);
  return cell;
  }

function append_audio_broadcast(parent, el)
  {
  var row1;
  var cell;
  var text;
  var button;
  var trackno;
  var station_url;
  var row = document.createElement("table");
  row.setAttribute("id", el.getAttribute("id"));
  row.setAttribute("class", "mediaitem");
  row1 = document.createElement("tr");
  row1.setAttribute("class", "mediaitem_title");
  row.appendChild(row1);
  row1.appendChild(create_type_cell("audio"));
  cell = document.createElement("td");
  text = document.createTextNode(get_didl_element(el, "title"));

  station_url = get_didl_element(el, "stationURL");

  if(station_url != null)
    {
    var a = document.createElement("a");
    a.setAttribute("href", station_url);
    a.setAttribute("target", "_new");
    a.appendChild(text);
    cell.appendChild(a);
    }
  else
    cell.appendChild(text);
  row1.appendChild(cell);

  /* Play */
  cell = document.createElement("td");
  cell.setAttribute("style", "width: 16px;");
  button = create_song_play_button(el.getAttribute('id'));
  cell.appendChild(button);
  row1.appendChild(cell);

  /* Info */
  row1 = document.createElement("tr");
  row1.setAttribute("class", "mediaitem");

  /* Empty cell */
  cell = document.createElement("td");
  row1.appendChild(cell);

  /* Info cell */
  cell = document.createElement("td");
  add_music_info(el, cell);
  text = document.createTextNode(" ");
  cell.appendChild(text);
  add_media_locations(el, cell);

  row1.appendChild(cell);
  row.appendChild(row1);


  parent.appendChild(row);
  row = document.createElement("hr");
  row.setAttribute("style", "margin-top: 0px; margin-bottom: 0px;");
  parent.appendChild(row);

  }

function append_music_track(parent, el)
  {
  var str1;
  var str2;
  var str3;
  var str;
  var row1;
  var text;
  var cell;
  var button;
  var trackno;
  var row = document.createElement("table");
  row.setAttribute("id", el.getAttribute("id"));
  row.setAttribute("class", "mediaitem");
  row1 = document.createElement("tr");
  row1.setAttribute("class", "mediaitem_title");
  row.appendChild(row1);

  /* Artist, title */
  str1 = get_didl_element(el, "title");
  str2 = get_didl_element(el, "artist");

  row1.appendChild(create_type_cell("audio"));

  cell = document.createElement("td");
  if((str1 != null) && (str2 != null))
    text = document.createTextNode(str2 + ": " + str1);
  else if(str2 != null)
    text = document.createTextNode(str2);

  cell.appendChild(text);

  row1.appendChild(cell);

  /* Duration */
  str1 = get_duration(el);
  cell = document.createElement("td");
  cell.setAttribute("style", "text-align: right;");
  text = document.createTextNode(format_duration_str(str1));

  cell.appendChild(text);
  row1.appendChild(cell);

  /* Play */
  cell = document.createElement("td");
  cell.setAttribute("style", "width: 16px;");
  button = create_song_play_button(el.getAttribute('id'));
  cell.appendChild(button);
  row1.appendChild(cell);

  /* Add */
  cell = document.createElement("td");
  cell.setAttribute("style", "width: 16px;");
  button = create_song_add_button(el.getAttribute('id'));
  cell.appendChild(button);
  row1.appendChild(cell);


  str1 = get_didl_element(el, "album");
  str2 = get_didl_element(el, "genre");
  str3 = get_didl_element(el, "date");
  trackno = get_didl_element(el, "originalTrackNumber");

  str = null;
  if(str1 != null)
    {
    str = str1;
    if(trackno != null)
      str += " (Track " + trackno + ")";
    }

  if(str2 != null)
    {
    if(str != null)
      str += ", " + str2;
    else
      str = str2;
    }
  if(str3 != null)
    {
    if(str != null)
      str += ", " + str3.substring(0, 4);
    else
      str = str3.substring(0, 4);
    }

  row1 = document.createElement("tr");
  cell = document.createElement("td");
  row1.appendChild(cell);

  cell = document.createElement("td");

  if(str != null)
    {
    text = document.createTextNode(str);
    cell.appendChild(text);
    }

  row1.appendChild(cell);
  row.appendChild(row1);

  row1 = document.createElement("tr");
  cell = document.createElement("td");
  row1.appendChild(cell);
  cell = document.createElement("td");

  add_music_info(el, cell);
  text = document.createTextNode(" ");
  cell.appendChild(text);
  add_media_locations(el, cell);

  row1.appendChild(cell);
  row.appendChild(row1);

  parent.appendChild(row);

  row = document.createElement("hr");
  row.setAttribute("style", "margin-top: 0px; margin-bottom: 0px;");
  parent.appendChild(row);
  }

function append_music_album(parent, el)
  {
  var play_button;
  var tracks;
  var i;
  var didl;
  var str;
  var albumdiv;
  var trackstable;
  var albumcell;
  var trackscell;
  var span;
  var text;
  var row1;
  var img;
  var dur_total = 0;
  var added = 0;
  var use_artist = false;
  var first_artist = null;
  var has_year = false;
  var row = document.createElement("table");
  row.setAttribute("id", el.getAttribute("id"));
  row.setAttribute("style", "width: 100%;");

  row1 = document.createElement("tr");

  row.appendChild(row1);

  albumcell = document.createElement("td");
  albumcell.setAttribute("style", "width: 162px; padding: 10px; vertical-align: top;");

  /* Cover */
  img = create_album_cover(el);
  if(img != null)
    albumcell.appendChild(img);
  albumcell.appendChild(document.createElement("br"));

  /* Title */

  str = get_didl_element(el, "title");
  if(str != null)
    {
    span = document.createElement("span");
    span.setAttribute("class", "albumtitle");
    text = document.createTextNode(str);
    span.appendChild(text);
    albumcell.appendChild(span);
    albumcell.appendChild(document.createElement("br"));
    }

  str = get_didl_element(el, "artist");
  if(str != null)
    {
    span = document.createElement("span");
    span.setAttribute("class", "albuminfo");
    text = document.createTextNode(str);
    span.appendChild(text);
    albumcell.appendChild(span);
    albumcell.appendChild(document.createElement("br"));
    }
  str = get_didl_element(el, "date");
  if(str != null)
    {
    span = document.createElement("span");
    span.setAttribute("class", "albuminfo");
    text = document.createTextNode(str.substring(0, 4));
    span.appendChild(text);
    albumcell.appendChild(span);
    albumcell.appendChild(document.createElement("br"));
    has_year = true;
    }
  str = get_didl_element(el, "genre");
  if(str != null)
    {
    span = document.createElement("span");
    span.setAttribute("class", "albuminfo");
    text = document.createTextNode(str);
    span.appendChild(text);
    albumcell.appendChild(span);
    albumcell.appendChild(document.createElement("br"));
    }
  row1.appendChild(albumcell);

  /* Tracks */

  trackscell = document.createElement("td");
  trackscell.setAttribute("style", "vertical-align: top; padding-right: 10px; padding-top: 10px; padding-bottom: 10px;");

  didl = browse_children(el.getAttribute("id"));
  tracks = didl.getElementsByTagName("DIDL-Lite")[0].childNodes;
  trackstable = document.createElement("table");
  trackstable.setAttribute("class", "mediaitem");

  /* If all artists are the same, we omit it from the label */
  for(i=0; i < tracks.length; i++)
    {
    if(get_didl_element(tracks[i], "class") ==
       "object.item.audioItem.musicTrack")
      {
      if(first_artist == null)
	first_artist = get_didl_element(tracks[i], "artist");
      else if(get_didl_element(tracks[i], "artist") != first_artist)
	{
	use_artist = true;
	break;
	}
      }
    }

  for(i=0; i < tracks.length; i++)
    {
    var track_row;
    var track_cell;
    var hr;
    if(get_didl_element(tracks[i], "class") ==
       "object.item.audioItem.musicTrack")
      {
      if(added > 0)
	{
        track_row = document.createElement("tr");
        track_cell = document.createElement("td");

        if(has_year == false)
	  track_cell.setAttribute("colspan", "6");
        else
	  track_cell.setAttribute("colspan", "5");
        hr = document.createElement("hr");
        hr.setAttribute("style", "margin-top: 0px; margin-bottom: 0px;");
        track_cell.appendChild(hr);
        track_row.appendChild(track_cell);
        trackstable.appendChild(track_row);
	}

      track_row = document.createElement("tr");
//      track_row.setAttribute("class", "mediaitem_title");

      /* Number */
      str = get_didl_element(tracks[i], "originalTrackNumber");

      track_cell = document.createElement("td");
      track_cell.setAttribute("class", "mediaitem_title");
      track_cell.setAttribute("style", "margin-right: 3px; width: 26px; text-align: right;");

      text = document.createTextNode(str + ".");
      track_cell.appendChild(text);
      track_row.appendChild(track_cell);

      /* Title */

      if(use_artist)
	str = get_didl_element(tracks[i], "artist") +
	  ": " + get_didl_element(tracks[i], "title");
      else
	str = get_didl_element(tracks[i], "title");
      track_cell = document.createElement("td");
      track_cell.setAttribute("class", "mediaitem_title");
      text = document.createTextNode(str);
      track_cell.appendChild(text);
      track_row.appendChild(track_cell);

      /* Year (if available) */

      if(has_year == false)
	{
        track_cell = document.createElement("td");
        track_cell.setAttribute("style", "margin-right: 3px; width: 26px; text-align: right;");
	str = get_didl_element(tracks[i], "date");
        if(str != null)
	  {
          str = str.substring(0, 4);
          text = document.createTextNode(str);
          track_cell.appendChild(text);
	  }
        track_row.appendChild(track_cell);
	}

      /* Duration */
      str = get_duration(tracks[i]);
      if(str != null)
        dur_total += get_duration_num(str);
      track_cell = document.createElement("td");
      track_cell.setAttribute("class", "mediaitem_title");

      track_cell.setAttribute("style", "text-align: right; width: 30px;");
      text = document.createTextNode(format_duration_str(str));
      track_cell.appendChild(text);
      track_row.appendChild(track_cell);

      /* Play */
      track_cell = document.createElement("td");
      track_cell.setAttribute("style", "width: 16px;");
      play_button = create_song_play_button(tracks[i].getAttribute('id'));
      track_cell.appendChild(play_button);
      track_row.appendChild(track_cell);

      /* Add */
      track_cell = document.createElement("td");
      track_cell.setAttribute("style", "width: 16px;");
      play_button = create_song_add_button(tracks[i].getAttribute('id'));
      track_cell.appendChild(play_button);
      track_row.appendChild(track_cell);
      trackstable.appendChild(track_row);

      /* URLs */
      track_row = document.createElement("tr");
      track_row.setAttribute("class", "mediaitem");

      track_cell = document.createElement("td");
      track_row.appendChild(track_cell);

      track_cell = document.createElement("td");
      track_cell.setAttribute("style", "text-align: left;");
      track_cell.setAttribute("colspan", "4");

      add_music_info(tracks[i], track_cell);
      add_media_locations(tracks[i], track_cell);
      track_row.appendChild(track_cell);
      trackstable.appendChild(track_row);
      added++;
      }
    }
  /* Total duration */
  str = get_duration_str(dur_total);

  span = document.createElement("span");
  span.setAttribute("class", "albuminfo");
  text = document.createTextNode("Total: " + str + " ");
  span.appendChild(text);
  albumcell.appendChild(span);

  play_button = create_album_play_button(el.getAttribute('id'));
  albumcell.appendChild(play_button);

  play_button = create_album_add_button(el.getAttribute('id'));
  albumcell.appendChild(play_button);

  albumcell.appendChild(document.createElement("br"));
  add_media_locations(el, albumcell);

  trackscell.appendChild(trackstable);
  row1.appendChild(trackscell);

  parent.appendChild(row);
  parent.appendChild(document.createElement("hr"));
  }


//

function get_movie_files(el)
  {
  var klass;
  var children = new Array();

  klass = get_didl_element(el, "class");
  if(klass == "object.item.videoItem.movie")
    children[0] = el;
  else
    {
    var arr;
    var parts;
    var i;
    var idx = 0;
    arr = browse_children(el.getAttribute("id"));
    parts = arr.getElementsByTagName("DIDL-Lite")[0].childNodes;

    for(i = 0; i < parts.length; i++)
      {
      if(parts[i].getElementsByTagName)
	{
        children[idx] = parts[i];
        idx++;
        }
      }
    }
  return children;
  }

function append_movie(parent, el)
  {
  var str;
  var str1, str2;
  var row1;
  var img;
  var postercell;
  var textcell;
  var span;
  var text;
  var arr;
  var children;
  var i;
  var duration;
  var duration_str;
  var has_audio_language = false;
  var row = document.createElement("table");
  row.setAttribute("id", el.getAttribute("id"));
  row.setAttribute("style", "width: 100%;");

  children = get_movie_files(el);

  row1 = document.createElement("tr");

  postercell = document.createElement("td");
  postercell.setAttribute("style",
			  "width: 220px; padding: 10px; vertical-align: top;");

  img = create_movie_poster(el);
  if(img != null)
    postercell.appendChild(img);

  row1.appendChild(postercell);

  textcell = document.createElement("td");
  textcell.setAttribute("style", "vertical-align: top; padding-top: 10px; padding-right: 10px; padding-bottom: 10px;");

  /* Title */
  str = get_didl_element(el, "title");
  span = document.createElement("span");
  span.setAttribute("class", "movietitle");
  text = document.createTextNode(str);
  span.appendChild(text);
  textcell.appendChild(span);

  /* Original title */
  str = get_didl_element(el, "originalTitle");
  if(str != null)
    {
    textcell.appendChild(document.createElement("br"));
    span = document.createElement("span");
    span.setAttribute("class", "movieinfo");
    text = document.createTextNode("(" + str + ")");
    span.appendChild(text);
    textcell.appendChild(span);
    }

  /* Countries */
  str1 = null;
  arr = el.getElementsByTagNameNS("*", "productionCountry");
  if((arr != null) && (arr.length > 0))
    {
    str1 = "";
    for(i = 0; i < arr.length; i++)
      {
      if(i > 0)
	str1 += ", ";
      str1 += arr[i].textContent;
      }
    }
  /* Year */
  str2 = get_didl_element(el, "date");

  if(str2 != null)
    str2 = str2.substring(0, 4);

  if((str1 != null) && (str2 != null))
    str = str1 + ", " + str2;
  else if(str1)
    str = str1;
  else if(str2)
    str = str2;
  else
    str = null;

  if(str != null)
    {
    textcell.appendChild(document.createElement("br"));
    span = document.createElement("span");
    span.setAttribute("class", "movieinfo");
    text = document.createTextNode(str);
    span.appendChild(text);
    textcell.appendChild(span);
    }

  /* Genres */
  arr = el.getElementsByTagNameNS("*", "genre");
  if((arr != null) && (arr.length > 0))
    {
    textcell.appendChild(document.createElement("br"));
    str = "";
    for(i = 0; i < arr.length; i++)
      {
      if(i > 0)
	str += ", ";
      str += arr[i].textContent;
      }
    span = document.createElement("span");
    span.setAttribute("class", "movieinfo");
    text = document.createTextNode(str);
    span.appendChild(text);
    textcell.appendChild(span);
    }

  /* Duration */
  duration = 0;
  for(i = 0; i < children.length; i++)
    {
    duration_str = get_duration(children[i]);
    duration += get_duration_num(duration_str);
    }
  duration_str = get_duration_str(duration);
  textcell.appendChild(document.createElement("br"));
  span = document.createElement("span");
  span.setAttribute("class", "movieinfo");
  text = document.createTextNode(duration_str);
  span.appendChild(text);
  textcell.appendChild(span);

  /* Links */

  if(children.length == 1) // Single part movie
    {
    textcell.appendChild(document.createElement("br"));

    span = document.createElement("span");
    span.setAttribute("class", "movieinfo");
    add_video_info(el, span);
    textcell.appendChild(span);
    textcell.appendChild(document.createTextNode(" "));
    add_media_locations(el, textcell);
    }
  else // Multi part movie
    {
    for(i = 0; i < children.length; i++)
      {
      textcell.appendChild(document.createElement("br"));
      span = document.createElement("span");
      span.setAttribute("class", "movieinfo");
      text = document.createTextNode("Part " + (i+1) + ": ");
      span.appendChild(text);
      add_video_info(children[i], span);
      textcell.appendChild(span);
      textcell.appendChild(document.createTextNode(" "));
      add_media_locations(children[i], textcell);
      }
    }

  /* Audio Language */      
  arr = el.getElementsByTagNameNS("*", "audioLanguage");
  if((arr != null) && (arr.length > 0))
    {
    textcell.appendChild(document.createElement("p"));
    if(arr.length > 1)
      str = "Spoken languages: ";
    else
      str = "Spoken language: ";
	
    span = document.createElement("span");
    span.setAttribute("class", "movietitle");
    text = document.createTextNode(str);
    span.appendChild(text);
    textcell.appendChild(span);

    str = "";
    for(i = 0; i < arr.length; i++)
      {
      if(i > 0)
	str += ", ";
      str += arr[i].textContent;
      }
    span = document.createElement("span");
    span.setAttribute("class", "movieinfo");
    text = document.createTextNode(str);
    span.appendChild(text);
    textcell.appendChild(span);
    has_audio_language = true;
    }

  /* Subtitle language */      
  arr = el.getElementsByTagNameNS("*", "subtitleLanguage");
  if((arr != null) && (arr.length > 0))
    {
    if(has_audio_language == true)
      textcell.appendChild(document.createElement("br"));
    else
      textcell.appendChild(document.createElement("p"));
    if(arr.length > 1)
      str = "Subtitle languages: ";
    else
      str = "Subtitle language: ";
	
    span = document.createElement("span");
    span.setAttribute("class", "movietitle");
    text = document.createTextNode(str);
    span.appendChild(text);
    textcell.appendChild(span);

    str = "";
    for(i = 0; i < arr.length; i++)
      {
      if(i > 0)
	str += ", ";
      str += arr[i].textContent;
      }
    span = document.createElement("span");
    span.setAttribute("class", "movieinfo");
    text = document.createTextNode(str);
    span.appendChild(text);
    textcell.appendChild(span);
    }
      

  /* Directors */
  arr = el.getElementsByTagNameNS("*", "director");
  if((arr != null) && (arr.length > 0))
    {
    textcell.appendChild(document.createElement("p"));
    if(arr.length > 1)
      str = "Directors: ";
    else
      str = "Director: ";

    span = document.createElement("span");
    span.setAttribute("class", "movietitle");
    text = document.createTextNode(str);
    span.appendChild(text);
    textcell.appendChild(span);

    str = "";
    for(i = 0; i < arr.length; i++)
      {
      if(i > 0)
	str += ", ";
      str += arr[i].textContent;
      }
    span = document.createElement("span");
    span.setAttribute("class", "movieinfo");
    text = document.createTextNode(str);
    span.appendChild(text);
    textcell.appendChild(span);
    }
      
  /* Actors */
  arr = el.getElementsByTagNameNS("*", "actor");
  if((arr != null) && (arr.length > 0))
    {
    textcell.appendChild(document.createElement("p"));
    str = "Cast:";
    span = document.createElement("span");
    span.setAttribute("class", "movietitle");
    text = document.createTextNode(str);
    span.appendChild(text);
    textcell.appendChild(span);

    str = "";
    for(i = 0; i < arr.length; i++)
      {
      textcell.appendChild(document.createElement("br"));
      span = document.createElement("span");
      span.setAttribute("class", "movieinfo");
      text = document.createTextNode(arr[i].textContent);
      span.appendChild(text);
      textcell.appendChild(span);
      }
    }

  row1.appendChild(textcell);
  row.appendChild(row1);

  /* Plot */
  arr = el.getElementsByTagNameNS("*", "longDescription");
  if((arr != null) && (arr.length > 0))
    {
    var lines = arr[0].textContent.replace(/\r\n/, "\n").split("\n");

    row1 = document.createElement("tr");
    textcell = document.createElement("td");
    textcell.setAttribute("colspan", "2");
    textcell.setAttribute("style", "padding: 10px;");

    for(i = 0; i < lines.length; i++)
      {
      if(i > 0)
        textcell.appendChild(document.createElement("br"));

      span = document.createElement("span");
      span.setAttribute("class", "movieinfo");
      text = document.createTextNode(lines[i]);
      span.appendChild(text);
      textcell.appendChild(span);
      }


    row1.appendChild(textcell);
    row.appendChild(row1);
    }
  parent.appendChild(row);

  parent.appendChild(document.createElement("hr"));
  }

function append_series(parent, el)
  {
  var str;
  var str1, str2;
  var row1;
  var img;
  var postercell;
  var textcell;
  var span;
  var text;
  var arr;
  var i;
  var row = document.createElement("table");
  row.setAttribute("id", "seriesinfo");
  row.setAttribute("style", "width: 100%;");

  row1 = document.createElement("tr");

  postercell = document.createElement("td");
  postercell.setAttribute("style",
			  "width: 220px; padding: 10px; vertical-align: top;");

  img = create_movie_poster(el);
  if(img != null)
    postercell.appendChild(img);

  row1.appendChild(postercell);

  textcell = document.createElement("td");
  textcell.setAttribute("style", "vertical-align: top; padding-top: 10px; padding-right: 10px; padding-bottom: 10px;");

  /* Title */
  str = get_didl_element(el, "title");
  span = document.createElement("span");
  span.setAttribute("class", "movietitle");
  text = document.createTextNode(str);
  span.appendChild(text);
  textcell.appendChild(span);

  /* Original title */
  str = get_didl_element(el, "originalTitle");
  if(str != null)
    {
    textcell.appendChild(document.createElement("br"));
    span = document.createElement("span");
    span.setAttribute("class", "movieinfo");
    text = document.createTextNode("(" + str + ")");
    span.appendChild(text);
    textcell.appendChild(span);
    }

  /* Countries */
  str1 = null;
  arr = el.getElementsByTagNameNS("*", "productionCountry");
  if((arr != null) && (arr.length > 0))
    {
    str1 = "";
    for(i = 0; i < arr.length; i++)
      {
      if(i > 0)
	str1 += ", ";
      str1 += arr[i].textContent;
      }
    }
  /* Year */
  str2 = get_didl_element(el, "date");

  if(str2 != null)
    str2 = str2.substring(0, 4);

  if((str1 != null) && (str2 != null))
    str = str1 + ", " + str2;
  else if(str1)
    str = str1;
  else if(str2)
    str = str2;
  else
    str = null;

  if(str != null)
    {
    textcell.appendChild(document.createElement("br"));
    span = document.createElement("span");
    span.setAttribute("class", "movieinfo");
    text = document.createTextNode(str);
    span.appendChild(text);
    textcell.appendChild(span);
    }

  /* Genres */
  arr = el.getElementsByTagNameNS("*", "genre");
  if((arr != null) && (arr.length > 0))
    {
    textcell.appendChild(document.createElement("br"));
    str = "";
    for(i = 0; i < arr.length; i++)
      {
      if(i > 0)
	str += ", ";
      str += arr[i].textContent;
      }
    span = document.createElement("span");
    span.setAttribute("class", "movieinfo");
    text = document.createTextNode(str);
    span.appendChild(text);
    textcell.appendChild(span);
    }

  /* Directors */
  arr = el.getElementsByTagNameNS("*", "director");
  if((arr != null) && (arr.length > 0))
    {
    textcell.appendChild(document.createElement("p"));
    if(arr.length > 1)
      str = "Directors: ";
    else
      str = "Director: ";

    span = document.createElement("span");
    span.setAttribute("class", "movietitle");
    text = document.createTextNode(str);
    span.appendChild(text);
    textcell.appendChild(span);

    str = "";
    for(i = 0; i < arr.length; i++)
      {
      if(i > 0)
	str += ", ";
      str += arr[i].textContent;
      }
    span = document.createElement("span");
    span.setAttribute("class", "movieinfo");
    text = document.createTextNode(str);
    span.appendChild(text);
    textcell.appendChild(span);
    }
  /* Actors */
  arr = el.getElementsByTagNameNS("*", "actor");
  if((arr != null) && (arr.length > 0))
    {
    textcell.appendChild(document.createElement("p"));
    str = "Cast:";
    span = document.createElement("span");
    span.setAttribute("class", "movietitle");
    text = document.createTextNode(str);
    span.appendChild(text);
    textcell.appendChild(span);

    str = "";
    for(i = 0; i < arr.length; i++)
      {
      textcell.appendChild(document.createElement("br"));
      span = document.createElement("span");
      span.setAttribute("class", "movieinfo");
      text = document.createTextNode(arr[i].textContent);
      span.appendChild(text);
      textcell.appendChild(span);
      }
    }

  row1.appendChild(textcell);
  row.appendChild(row1);

  /* Plot */
  arr = el.getElementsByTagNameNS("*", "longDescription");
  if((arr != null) && (arr.length > 0))
    {
    var lines = arr[0].textContent.replace(/\r\n/, "\n").split("\n");

    row1 = document.createElement("tr");
    textcell = document.createElement("td");
    textcell.setAttribute("colspan", "2");
    textcell.setAttribute("style", "padding: 10px;");

    for(i = 0; i < lines.length; i++)
      {
      if(i > 0)
        textcell.appendChild(document.createElement("br"));

      span = document.createElement("span");
      span.setAttribute("class", "movieinfo");
      text = document.createTextNode(lines[i]);
      span.appendChild(text);
      textcell.appendChild(span);
      }


    row1.appendChild(textcell);
    row.appendChild(row1);
    }
  parent.appendChild(row);

  parent.appendChild(document.createElement("hr"));
  }

function append_season(parent, el)
  {
  var didl;
  var episodes;
  var str;
  var span;
  var text;
  var table;
  var i;
  var row, cell;
  var added = 0;
  var season_table;
  var season_row;
  var season_info;
  var season_ep;
  var img;

  if(!document.getElementById("seriesinfo"))
    {
    didl = browse_metadata(el.getAttribute("parentID"));
    var series =  didl.getElementsByTagName("DIDL-Lite")[0].childNodes[0];
    append_series(parent, series);
    }

  season_table = document.createElement("table");
  season_table.setAttribute("class", "mediaitem");

  parent.appendChild(season_table);

  season_row = document.createElement("tr");
  season_table.appendChild(season_row);

  season_info = document.createElement("td");
  season_info.setAttribute("style",
			   "width: 240px; padding: 10px; vertical-align: top;");

  season_row.appendChild(season_info);

  season_ep = document.createElement("td");
  season_ep.setAttribute("style",
                         "padding: 10px; vertical-align: top;");
  season_row.appendChild(season_ep);

  // Season header
  img = create_movie_poster(el);
  if(img != null)
    {
    season_info.appendChild(img);
    season_info.appendChild(document.createElement("br"));
    }


  str = get_didl_element(el, "title");
  span = document.createElement("span");
  span.setAttribute("class", "mediaitem_title");

  text = document.createTextNode(str);
  span.appendChild(text);
  season_info.appendChild(span);
  season_info.appendChild(document.createElement("br"));

  add_media_locations(el, season_info);

  didl = browse_children(el.getAttribute("id"));
  episodes = didl.getElementsByTagName("DIDL-Lite")[0].childNodes;

  table = document.createElement("table");
  table.setAttribute("class", "mediaitem");

  for(i=0; i < episodes.length; i++)
    {
    if(get_didl_element(episodes[i], "class") ==
       "object.item.videoItem.movie")
      {
      if(added > 0)
	{
        var hr = document.createElement("hr");
        hr.setAttribute("style", "margin-top: 0px; margin-bottom: 0px;");
        row = document.createElement("tr");
        cell = document.createElement("td");
        cell.setAttribute("colspan", "3");

        cell.appendChild(hr);
        row.appendChild(cell);
        table.appendChild(row);
	}

      row = document.createElement("tr");

      /* Number */
      str = get_didl_element(episodes[i], "episodeIndex");
      cell = document.createElement("td");
      cell.setAttribute("class",
			"mediaitem_title");
      cell.setAttribute("style",
			"margin-right: 3px; width: 26px; text-align: right;");

      text = document.createTextNode(str + ".");
      cell.appendChild(text);
      row.appendChild(cell);

      /* Title */
      str = get_didl_element(episodes[i], "title");
      cell = document.createElement("td");
      span = document.createElement("span");
      span.setAttribute("class",
			"mediaitem_title");
      text = document.createTextNode(str);
      span.appendChild(text);
      cell.appendChild(span);

      str = get_didl_element(episodes[i], "date");
      if(str != null)
    	{
        span = document.createElement("span");
        text = document.createTextNode(" (" + str + ")");
        span.appendChild(text);
        cell.appendChild(span);
	}
      row.appendChild(cell);

      /* Duration */
      str = get_duration(episodes[i]);
      cell = document.createElement("td");
      cell.setAttribute("class",
			"mediaitem_title");

      cell.setAttribute("style", "text-align: right; padding-right: 10px;");
      text = document.createTextNode(format_duration_str(str));
      cell.appendChild(text);
      row.appendChild(cell);

      table.appendChild(row);

      /* Second row */
      row = document.createElement("tr");
      row.appendChild(document.createElement("td"));

      cell = document.createElement("td");

      add_video_info(episodes[i], cell);
      text = document.createTextNode(" ");
      cell.appendChild(text);

      add_media_locations(episodes[i], cell);
      row.appendChild(cell);
      table.appendChild(row);
      added++;
      }
    }
  season_ep.appendChild(table);
  row =	document.createElement("hr");
  parent.appendChild(row);
  }

function add_song(id)
  {
  var didl;
  didl = browse_metadata(id);
  add_audio_track(didl.getElementsByTagName("item")[0], false);
  }

function handle_didl_item(el)
  {
  var container = document.getElementById("list");
  var klass = get_didl_element(el, "class");

  if(klass == "object.container.album.musicAlbum")
    {
    append_music_album(container, el);
    }
  else if(klass == "object.item.audioItem.musicTrack")
    {
    append_music_track(container, el);
    }
  else if(klass == "object.item.audioItem.audioBroadcast")
    {
    append_audio_broadcast(container, el);
    }
  else if((klass == "object.item.videoItem.movie") ||
	  (((klass == "object.container.album.videoAlbum")) &&
	   (get_didl_element(el, "subType") == "multifileMovie")))
    {
    append_movie(container, el);
    }
  else if((klass == "object.container.album.videoAlbum") &&
	   (get_didl_element(el, "subType") == "season"))
    {
    append_season(container, el);
    }
  else
    {
    var text;
    var row = document.createElement("div");
    text = document.createTextNode(get_didl_element(el, "title"));
    row.appendChild(text);
    container.appendChild(row);
    }

  }

function handle_didl_container(el, parent, after)
  {
  var button;
  var element;
  var text;
  var i;
  var title;
  var container = document.getElementById("tree");
  var row = document.createElement("div");

  row.setAttribute("class", "treerow");
  row.setAttribute("id", el.getAttribute("id"));
  row.onmousedown = function() { tree_select_callback(this); };

  if(parent != null)
    {
    row.depth = parent.depth + 1;

    for(i = 0; i < row.depth; i++)
      {
      element = document.createElement("div");
      element.setAttribute("class", "tree_elem");
      row.appendChild(element);
      }
    }
  else
    row.depth = 0;

  element = document.createElement("div");
  element.setAttribute("class", "tree_elem handleclosed");
  element.onmousedown = function(event) {
  tree_expand_callback(event, this); };

  row.appendChild(element);

  element = document.createElement("div");
  element.setAttribute("class", "tree_elem folderclosed");
  row.appendChild(element);

  element = document.createElement("span");
//  element.setAttribute("class", "treerow");
  title = get_didl_element(el, "title");
  text = document.createTextNode(title);

  element.appendChild(text);
  row.setAttribute("title", title);

  row.appendChild(element);

  if(get_didl_element(el, "class") == "object.container.playlistContainer")
    {
    button = create_add_button("add_album", el.getAttribute("id"));
    row.appendChild(button);
    }

  if(after == null)
    container.appendChild(row);
  else
    container.insertBefore(row, after);

  return row;
  }

function is_item(el)
  {
  var cl;

  if(el.nodeName == "item")
    return true;

  cl = get_didl_element(el, "class");

  if(cl == "object.container.album.musicAlbum")
    return true;

  if(cl == "object.container.album.videoAlbum")
    {
    var st = get_didl_element(el, "subType");
    if((st == "multifileMovie") ||
       (st == "season"))
      return true;
    }
  return false;
  }

function is_container(el)
  {
  if(el.nodeType != 1)
    return false;

  if(is_item(el))
    return false;
  else
    return true;
  }


function handle_didl_containers(didl, parent)
  {
  var elements, i;
  var after;
  if(parent != null)
    after = parent.nextSibling;
  else
    after = null;

  elements = didl.getElementsByTagName("DIDL-Lite")[0].childNodes;

  for(i=0; i<elements.length; i++)
    {
    if(is_container(elements[i]))
      handle_didl_container(elements[i], parent, after);
    }
  }

var didl_items = null;
var didl_index = 0;

function didl_timeout()
  {
  var i;
  for(i = 0; i < 5; i++)
    {
    if(is_item(didl_items[didl_index]))
      handle_didl_item(didl_items[didl_index]);
    didl_index++;
    if(didl_index >= didl_items.length)
      return;
    }
  if(didl_index < didl_items.length)
    window.setTimeout(didl_timeout, 1);
  else
    didl_items = null;
  }

function handle_didl_items(didl)
  {
  didl_items = didl.getElementsByTagName("DIDL-Lite")[0].childNodes;
  didl_index = 0;
  didl_timeout();
  }

var device_desc = null;

function global_init()
  {
  var didl;
  /* Get device description */
  var req = make_http_request();
  req.open('GET', '/upnp/desc.xml', false);
  req.send();

  if(req.status != 200)
    {
    alert("Upnp initialization failed");
    return;
    }
  else
    {
    var el;
    var title = req.responseXML.getElementsByTagName("friendlyName")[0].textContent;
    document.title = title;
    el = document.getElementById("servername");
    el.appendChild(document.createTextNode(title));
    }
  didl = browse_children("0");
  handle_didl_containers(didl, null);
  audio_player_queue = new Array();
  }
